diff --git a/src/backend/utils/adt/tsquery_rewrite.c b/src/backend/utils/adt/tsquery_rewrite.c
index 1bd3dea..e90b702 100644
--- a/src/backend/utils/adt/tsquery_rewrite.c
+++ b/src/backend/utils/adt/tsquery_rewrite.c
@@ -326,13 +326,13 @@ tsquery_rewrite_query(PG_FUNCTION_ARGS)
 
 		for (i = 0; i < SPI_processed && tree; i++)
 		{
-			Datum		qdata = SPI_getbinval(SPI_tuptable->vals[i], SPI_tuptable->tupdesc, 1, &isnull);
+			Datum		qdata = SPI_getbinval(SPI_tuptable->vals[i], 1, &isnull);
 			Datum		sdata;
 
 			if (isnull)
 				continue;
 
-			sdata = SPI_getbinval(SPI_tuptable->vals[i], SPI_tuptable->tupdesc, 2, &isnull);
+			sdata = SPI_getbinval(SPI_tuptable->vals[i], 2, &isnull);
 
 			if (!isnull)
 			{
diff --git a/src/backend/utils/adt/tsvector_op.c b/src/backend/utils/adt/tsvector_op.c
index 2d7407c..448a2af 100644
--- a/src/backend/utils/adt/tsvector_op.c
+++ b/src/backend/utils/adt/tsvector_op.c
@@ -2357,7 +2357,7 @@ ts_stat_sql(MemoryContext persistentContext, text *txt, text *ws)
 
 		for (i = 0; i < SPI_processed; i++)
 		{
-			Datum		data = SPI_getbinval(SPI_tuptable->vals[i], SPI_tuptable->tupdesc, 1, &isnull);
+			Datum		data = SPI_getbinval(SPI_tuptable->vals[i], 1, &isnull);
 
 			if (!isnull)
 				stat = ts_accum(persistentContext, stat, data);
@@ -2456,7 +2456,7 @@ tsvector_update_trigger(PG_FUNCTION_ARGS, bool config_column)
 	TriggerData *trigdata;
 	Trigger    *trigger;
 	Relation	rel;
-	HeapTuple	rettuple = NULL;
+	TupleTableSlot *retslot = NULL;
 	int			tsvector_attr_num,
 				i;
 	ParsedText	prs;
@@ -2476,9 +2476,9 @@ tsvector_update_trigger(PG_FUNCTION_ARGS, bool config_column)
 		elog(ERROR, "tsvector_update_trigger: must be fired BEFORE event");
 
 	if (TRIGGER_FIRED_BY_INSERT(trigdata->tg_event))
-		rettuple = trigdata->tg_trigtuple;
+		retslot = trigdata->tg_trigslot;
 	else if (TRIGGER_FIRED_BY_UPDATE(trigdata->tg_event))
-		rettuple = trigdata->tg_newtuple;
+		retslot = trigdata->tg_newslot;
 	else
 		elog(ERROR, "tsvector_update_trigger: must be fired for INSERT or UPDATE");
 
@@ -2521,7 +2521,7 @@ tsvector_update_trigger(PG_FUNCTION_ARGS, bool config_column)
 					 errmsg("column \"%s\" is not of regconfig type",
 							trigger->tgargs[1])));
 
-		datum = SPI_getbinval(rettuple, rel->rd_att, config_attr_num, &isnull);
+		datum = SPI_getbinval(retslot, config_attr_num, &isnull);
 		if (isnull)
 			ereport(ERROR,
 					(errcode(ERRCODE_NULL_VALUE_NOT_ALLOWED),
@@ -2566,7 +2566,7 @@ tsvector_update_trigger(PG_FUNCTION_ARGS, bool config_column)
 					 errmsg("column \"%s\" is not of a character type",
 							trigger->tgargs[i])));
 
-		datum = SPI_getbinval(rettuple, rel->rd_att, numattr, &isnull);
+		datum = SPI_getbinval(retslot, numattr, &isnull);
 		if (isnull)
 			continue;
 
@@ -2583,9 +2583,11 @@ tsvector_update_trigger(PG_FUNCTION_ARGS, bool config_column)
 	{
 		datum = PointerGetDatum(make_tsvector(&prs));
 		isnull = false;
-		rettuple = heap_modify_tuple_by_cols(rettuple, rel->rd_att,
-											 1, &tsvector_attr_num,
-											 &datum, &isnull);
+
+		Assert(retslot->tts_tupleDescriptor != rel->rd_att);
+		retslot = heap_modify_slot_by_cols(retslot,
+									    	1, &tsvector_attr_num,
+											&datum, &isnull);
 		pfree(DatumGetPointer(datum));
 	}
 	else
@@ -2596,11 +2598,13 @@ tsvector_update_trigger(PG_FUNCTION_ARGS, bool config_column)
 		out->size = 0;
 		datum = PointerGetDatum(out);
 		isnull = false;
-		rettuple = heap_modify_tuple_by_cols(rettuple, rel->rd_att,
+
+		Assert(retslot->tts_tupleDescriptor != rel->rd_att);
+		retslot = heap_modify_slot_by_cols(retslot,
 											 1, &tsvector_attr_num,
 											 &datum, &isnull);
 		pfree(prs.words);
 	}
 
-	return PointerGetDatum(rettuple);
+	return PointerGetDatum(retslot->tts_tuple);
 }
diff --git a/src/backend/utils/adt/xml.c b/src/backend/utils/adt/xml.c
index 323614c..e0deec1 100644
--- a/src/backend/utils/adt/xml.c
+++ b/src/backend/utils/adt/xml.c
@@ -2331,7 +2331,6 @@ query_to_oid_list(const char *query)
 		bool		isnull;
 
 		oid = SPI_getbinval(SPI_tuptable->vals[i],
-							SPI_tuptable->tupdesc,
 							1,
 							&isnull);
 		if (!isnull)
@@ -3638,7 +3637,6 @@ SPI_sql_row_to_xmlelement(uint64 rownum, StringInfo result, char *tablename,
 		colname = map_sql_identifier_to_xml_name(SPI_fname(SPI_tuptable->tupdesc, i),
 												 true, false);
 		colval = SPI_getbinval(SPI_tuptable->vals[rownum],
-							   SPI_tuptable->tupdesc,
 							   i,
 							   &isnull);
 		if (isnull)
diff --git a/src/include/access/htup.h b/src/include/access/htup.h
index 61b3e68..cb3f9f0 100644
--- a/src/include/access/htup.h
+++ b/src/include/access/htup.h
@@ -68,6 +68,7 @@ typedef struct HeapTupleData
 } HeapTupleData;
 
 typedef HeapTupleData *HeapTuple;
+typedef void* StorageTuple;
 
 #define HEAPTUPLESIZE	MAXALIGN(sizeof(HeapTupleData))
 
diff --git a/src/include/commands/trigger.h b/src/include/commands/trigger.h
index 36c1134..7bf6e41 100644
--- a/src/include/commands/trigger.h
+++ b/src/include/commands/trigger.h
@@ -32,11 +32,9 @@ typedef struct TriggerData
 	NodeTag		type;
 	TriggerEvent tg_event;
 	Relation	tg_relation;
-	HeapTuple	tg_trigtuple;
-	HeapTuple	tg_newtuple;
+	TupleTableSlot*	tg_trigslot;
+	TupleTableSlot*	tg_newslot;
 	Trigger    *tg_trigger;
-	Buffer		tg_trigtuplebuf;
-	Buffer		tg_newtuplebuf;
 	Tuplestorestate *tg_oldtable;
 	Tuplestorestate *tg_newtable;
 } TriggerData;
@@ -188,7 +186,7 @@ extern TupleTableSlot *ExecBRInsertTriggers(EState *estate,
 					 TupleTableSlot *slot);
 extern void ExecARInsertTriggers(EState *estate,
 					 ResultRelInfo *relinfo,
-					 HeapTuple trigtuple,
+					 TupleTableSlot *slot,
 					 List *recheckIndexes,
 					 TransitionCaptureState *transition_capture);
 extern TupleTableSlot *ExecIRInsertTriggers(EState *estate,
@@ -203,15 +201,15 @@ extern bool ExecBRDeleteTriggers(EState *estate,
 					 EPQState *epqstate,
 					 ResultRelInfo *relinfo,
 					 ItemPointer tupleid,
-					 HeapTuple fdw_trigtuple);
+					 TupleTableSlot *trigslot);
 extern void ExecARDeleteTriggers(EState *estate,
 					 ResultRelInfo *relinfo,
 					 ItemPointer tupleid,
-					 HeapTuple fdw_trigtuple,
+					 TupleTableSlot *slot,
 					 TransitionCaptureState *transition_capture);
 extern bool ExecIRDeleteTriggers(EState *estate,
 					 ResultRelInfo *relinfo,
-					 HeapTuple trigtuple);
+					 TupleTableSlot *slot);
 extern void ExecBSUpdateTriggers(EState *estate,
 					 ResultRelInfo *relinfo);
 extern void ExecASUpdateTriggers(EState *estate,
@@ -221,18 +219,18 @@ extern TupleTableSlot *ExecBRUpdateTriggers(EState *estate,
 					 EPQState *epqstate,
 					 ResultRelInfo *relinfo,
 					 ItemPointer tupleid,
-					 HeapTuple fdw_trigtuple,
+					 TupleTableSlot *trigslot,
 					 TupleTableSlot *slot);
 extern void ExecARUpdateTriggers(EState *estate,
 					 ResultRelInfo *relinfo,
 					 ItemPointer tupleid,
-					 HeapTuple fdw_trigtuple,
-					 HeapTuple newtuple,
+					 TupleTableSlot *oldslot,
+					 TupleTableSlot *slot,
 					 List *recheckIndexes,
 					 TransitionCaptureState *transition_capture);
 extern TupleTableSlot *ExecIRUpdateTriggers(EState *estate,
 					 ResultRelInfo *relinfo,
-					 HeapTuple trigtuple,
+					 TupleTableSlot *oldslot,
 					 TupleTableSlot *slot);
 extern void ExecBSTruncateTriggers(EState *estate,
 					   ResultRelInfo *relinfo);
@@ -254,9 +252,9 @@ extern bool AfterTriggerPendingOnRel(Oid relid);
  * in utils/adt/ri_triggers.c
  */
 extern bool RI_FKey_pk_upd_check_required(Trigger *trigger, Relation pk_rel,
-							  HeapTuple old_row, HeapTuple new_row);
+							TupleTableSlot *oldslot, TupleTableSlot *newslot);
 extern bool RI_FKey_fk_upd_check_required(Trigger *trigger, Relation fk_rel,
-							  HeapTuple old_row, HeapTuple new_row);
+							TupleTableSlot *oldslot, TupleTableSlot *newslot);
 extern bool RI_Initial_Check(Trigger *trigger,
 				 Relation fk_rel, Relation pk_rel);
 
diff --git a/src/include/executor/spi.h b/src/include/executor/spi.h
index acade7e..ca93f89 100644
--- a/src/include/executor/spi.h
+++ b/src/include/executor/spi.h
@@ -25,7 +25,7 @@ typedef struct SPITupleTable
 	uint64		alloced;		/* # of alloced vals */
 	uint64		free;			/* # of free vals */
 	TupleDesc	tupdesc;		/* tuple descriptor */
-	HeapTuple  *vals;			/* tuples */
+	TupleTableSlot **vals;			/* tuples */
 	slist_node	next;			/* link for internal bookkeeping */
 	SubTransactionId subid;		/* subxact in which tuptable was created */
 } SPITupleTable;
@@ -121,10 +121,12 @@ extern HeapTuple SPI_copytuple(HeapTuple tuple);
 extern HeapTupleHeader SPI_returntuple(HeapTuple tuple, TupleDesc tupdesc);
 extern HeapTuple SPI_modifytuple(Relation rel, HeapTuple tuple, int natts,
 				int *attnum, Datum *Values, const char *Nulls);
+extern TupleTableSlot* SPI_modifyslot(TupleTableSlot *slot, int natts, int *attnum,
+				Datum *Values, const char *Nulls);
 extern int	SPI_fnumber(TupleDesc tupdesc, const char *fname);
 extern char *SPI_fname(TupleDesc tupdesc, int fnumber);
-extern char *SPI_getvalue(HeapTuple tuple, TupleDesc tupdesc, int fnumber);
-extern Datum SPI_getbinval(HeapTuple tuple, TupleDesc tupdesc, int fnumber, bool *isnull);
+extern char *SPI_getvalue(TupleTableSlot *slot, int fnumber);
+extern Datum SPI_getbinval(TupleTableSlot *slot, int fnumber, bool *isnull);
 extern char *SPI_gettype(TupleDesc tupdesc, int fnumber);
 extern Oid	SPI_gettypeid(TupleDesc tupdesc, int fnumber);
 extern char *SPI_getrelname(Relation rel);
diff --git a/src/include/executor/tuptable.h b/src/include/executor/tuptable.h
index 55f4cce..13706aa 100644
--- a/src/include/executor/tuptable.h
+++ b/src/include/executor/tuptable.h
@@ -117,6 +117,7 @@ typedef struct TupleTableSlot
 	bool		tts_shouldFree; /* should pfree tts_tuple? */
 	bool		tts_shouldFreeMin;	/* should pfree tts_mintuple? */
 	bool		tts_slow;		/* saved state for slot_deform_tuple */
+	ItemPointerData tts_tid;
 	HeapTuple	tts_tuple;		/* physical tuple, or NULL if virtual */
 	TupleDesc	tts_tupleDescriptor;	/* slot's tuple descriptor */
 	MemoryContext tts_mcxt;		/* slot itself is in this context */
@@ -152,6 +153,11 @@ extern TupleTableSlot *ExecStoreTuple(HeapTuple tuple,
 extern TupleTableSlot *ExecStoreMinimalTuple(MinimalTuple mtup,
 					  TupleTableSlot *slot,
 					  bool shouldFree);
+TupleTableSlot* heap_modify_slot_by_cols(TupleTableSlot *slot,
+						 int nCols,
+						 int *replCols,
+						 Datum *replValues,
+						 bool *replIsnull);
 extern TupleTableSlot *ExecClearTuple(TupleTableSlot *slot);
 extern TupleTableSlot *ExecStoreVirtualTuple(TupleTableSlot *slot);
 extern TupleTableSlot *ExecStoreAllNullTuple(TupleTableSlot *slot);
diff --git a/src/pl/plperl/plperl.c b/src/pl/plperl/plperl.c
index 5a45e3e..a760a24 100644
--- a/src/pl/plperl/plperl.c
+++ b/src/pl/plperl/plperl.c
@@ -1584,7 +1584,7 @@ plperl_trigger_build_args(FunctionCallInfo fcinfo)
 		event = "INSERT";
 		if (TRIGGER_FIRED_FOR_ROW(tdata->tg_event))
 			hv_store_string(hv, "new",
-							plperl_hash_from_tuple(tdata->tg_trigtuple,
+							plperl_hash_from_tuple(tdata->tg_trigslot,
 												   tupdesc));
 	}
 	else if (TRIGGER_FIRED_BY_DELETE(tdata->tg_event))
@@ -1592,7 +1592,7 @@ plperl_trigger_build_args(FunctionCallInfo fcinfo)
 		event = "DELETE";
 		if (TRIGGER_FIRED_FOR_ROW(tdata->tg_event))
 			hv_store_string(hv, "old",
-							plperl_hash_from_tuple(tdata->tg_trigtuple,
+							plperl_hash_from_tuple(tdata->tg_trigslot,
 												   tupdesc));
 	}
 	else if (TRIGGER_FIRED_BY_UPDATE(tdata->tg_event))
@@ -1601,10 +1601,10 @@ plperl_trigger_build_args(FunctionCallInfo fcinfo)
 		if (TRIGGER_FIRED_FOR_ROW(tdata->tg_event))
 		{
 			hv_store_string(hv, "old",
-							plperl_hash_from_tuple(tdata->tg_trigtuple,
+							plperl_hash_from_tuple(tdata->tg_trigslot,
 												   tupdesc));
 			hv_store_string(hv, "new",
-							plperl_hash_from_tuple(tdata->tg_newtuple,
+							plperl_hash_from_tuple(tdata->tg_newslot,
 												   tupdesc));
 		}
 	}
@@ -2486,13 +2486,13 @@ plperl_trigger_handler(PG_FUNCTION_ARGS)
 		TriggerData *trigdata = ((TriggerData *) fcinfo->context);
 
 		if (TRIGGER_FIRED_BY_INSERT(trigdata->tg_event))
-			retval = (Datum) trigdata->tg_trigtuple;
+			retval = (Datum) trigdata->tg_trigslot;
 		else if (TRIGGER_FIRED_BY_UPDATE(trigdata->tg_event))
-			retval = (Datum) trigdata->tg_newtuple;
+			retval = (Datum) trigdata->tg_newslot;
 		else if (TRIGGER_FIRED_BY_DELETE(trigdata->tg_event))
-			retval = (Datum) trigdata->tg_trigtuple;
+			retval = (Datum) trigdata->tg_trigslot;
 		else if (TRIGGER_FIRED_BY_TRUNCATE(trigdata->tg_event))
-			retval = (Datum) trigdata->tg_trigtuple;
+			retval = (Datum) trigdata->tg_trigslot;
 		else
 			retval = (Datum) 0; /* can this happen? */
 	}
@@ -2511,10 +2511,10 @@ plperl_trigger_handler(PG_FUNCTION_ARGS)
 
 			if (TRIGGER_FIRED_BY_INSERT(trigdata->tg_event))
 				trv = plperl_modify_tuple(hvTD, trigdata,
-										  trigdata->tg_trigtuple);
+										  trigdata->tg_trigslot);
 			else if (TRIGGER_FIRED_BY_UPDATE(trigdata->tg_event))
 				trv = plperl_modify_tuple(hvTD, trigdata,
-										  trigdata->tg_newtuple);
+										  trigdata->tg_newslot);
 			else
 			{
 				ereport(WARNING,
diff --git a/src/pl/plpgsql/src/pl_comp.c b/src/pl/plpgsql/src/pl_comp.c
index 662b3c9..019404d 100644
--- a/src/pl/plpgsql/src/pl_comp.c
+++ b/src/pl/plpgsql/src/pl_comp.c
@@ -1949,7 +1949,7 @@ plpgsql_build_record(const char *refname, int lineno, bool add2namespace)
 	rec->dtype = PLPGSQL_DTYPE_REC;
 	rec->refname = pstrdup(refname);
 	rec->lineno = lineno;
-	rec->tup = NULL;
+	rec->slot = NULL;
 	rec->tupdesc = NULL;
 	rec->freetup = false;
 	rec->freetupdesc = false;
diff --git a/src/pl/plpgsql/src/pl_exec.c b/src/pl/plpgsql/src/pl_exec.c
index c98492b..6f50937 100644
--- a/src/pl/plpgsql/src/pl_exec.c
+++ b/src/pl/plpgsql/src/pl_exec.c
@@ -275,7 +275,7 @@ static void plpgsql_param_fetch(ParamListInfo params, int paramid);
 static void exec_move_row(PLpgSQL_execstate *estate,
 			  PLpgSQL_rec *rec,
 			  PLpgSQL_row *row,
-			  HeapTuple tup, TupleDesc tupdesc);
+			  TupleTableSlot *slot, TupleDesc tupdesc);
 static HeapTuple make_tuple_from_row(PLpgSQL_execstate *estate,
 					PLpgSQL_row *row,
 					TupleDesc tupdesc);
@@ -612,7 +612,7 @@ plpgsql_exec_function(PLpgSQL_function *func, FunctionCallInfo fcinfo,
  *				trigger execution.
  * ----------
  */
-HeapTuple
+TupleTableSlot *
 plpgsql_exec_trigger(PLpgSQL_function *func,
 					 TriggerData *trigdata)
 {
@@ -668,23 +668,23 @@ plpgsql_exec_trigger(PLpgSQL_function *func,
 		/*
 		 * Per-statement triggers don't use OLD/NEW variables
 		 */
-		rec_new->tup = NULL;
-		rec_old->tup = NULL;
+		rec_new->slot = NULL;
+		rec_old->slot = NULL;
 	}
 	else if (TRIGGER_FIRED_BY_INSERT(trigdata->tg_event))
 	{
-		rec_new->tup = trigdata->tg_trigtuple;
-		rec_old->tup = NULL;
+		rec_new->slot = trigdata->tg_trigslot;
+		rec_old->slot = NULL;
 	}
 	else if (TRIGGER_FIRED_BY_UPDATE(trigdata->tg_event))
 	{
-		rec_new->tup = trigdata->tg_newtuple;
-		rec_old->tup = trigdata->tg_trigtuple;
+		rec_new->slot = trigdata->tg_newslot;
+		rec_old->slot = trigdata->tg_trigslot;
 	}
 	else if (TRIGGER_FIRED_BY_DELETE(trigdata->tg_event))
 	{
-		rec_new->tup = NULL;
-		rec_old->tup = trigdata->tg_trigtuple;
+		rec_new->slot = NULL;
+		rec_old->slot = trigdata->tg_trigslot;
 	}
 	else
 		elog(ERROR, "unrecognized trigger action: not INSERT, DELETE, or UPDATE");
@@ -1054,7 +1054,7 @@ copy_plpgsql_datum(PLpgSQL_datum *datum)
 
 				memcpy(new, datum, sizeof(PLpgSQL_rec));
 				/* should be preset to null/non-freeable */
-				Assert(new->tup == NULL);
+				Assert(new->slot == NULL);
 				Assert(new->tupdesc == NULL);
 				Assert(!new->freetup);
 				Assert(!new->freetupdesc);
@@ -1240,7 +1240,7 @@ exec_stmt_block(PLpgSQL_execstate *estate, PLpgSQL_stmt_block *block)
 
 					if (rec->freetup)
 					{
-						heap_freetuple(rec->tup);
+						ExecDropSingleTupleTableSlot(rec->slot);
 						rec->freetup = false;
 					}
 					if (rec->freetupdesc)
@@ -1248,7 +1248,7 @@ exec_stmt_block(PLpgSQL_execstate *estate, PLpgSQL_stmt_block *block)
 						FreeTupleDesc(rec->tupdesc);
 						rec->freetupdesc = false;
 					}
-					rec->tup = NULL;
+					rec->slot = NULL;
 					rec->tupdesc = NULL;
 				}
 				break;
@@ -2695,11 +2695,11 @@ exec_stmt_return(PLpgSQL_execstate *estate, PLpgSQL_stmt_return *stmt)
 					PLpgSQL_rec *rec = (PLpgSQL_rec *) retvar;
 					int32		rettypmod;
 
-					if (HeapTupleIsValid(rec->tup))
+					if (HeapTupleIsValid(rec->slot))
 					{
 						if (estate->retistuple)
 						{
-							estate->retval = PointerGetDatum(rec->tup);
+							estate->retval = PointerGetDatum(rec->slot->tts_tuple);
 							estate->rettupdesc = rec->tupdesc;
 							estate->retisnull = false;
 						}
@@ -2872,7 +2872,7 @@ exec_stmt_return_next(PLpgSQL_execstate *estate,
 					PLpgSQL_rec *rec = (PLpgSQL_rec *) retvar;
 					TupleConversionMap *tupmap;
 
-					if (!HeapTupleIsValid(rec->tup))
+					if (!HeapTupleIsValid(rec->slot))
 						ereport(ERROR,
 								(errcode(ERRCODE_OBJECT_NOT_IN_PREREQUISITE_STATE),
 								 errmsg("record \"%s\" is not assigned yet",
@@ -2885,7 +2885,7 @@ exec_stmt_return_next(PLpgSQL_execstate *estate,
 					tupmap = convert_tuples_by_position(rec->tupdesc,
 														tupdesc,
 														gettext_noop("wrong record type supplied in RETURN NEXT"));
-					tuple = rec->tup;
+					tuple = rec->slot->tts_tuple;
 					if (tupmap)
 						tuple = do_convert_tuple(tuple, tupmap);
 					tuplestore_puttuple(estate->tuple_store, tuple);
@@ -3058,10 +3058,11 @@ exec_stmt_return_query(PLpgSQL_execstate *estate,
 
 		for (i = 0; i < SPI_processed; i++)
 		{
-			HeapTuple	tuple = SPI_tuptable->vals[i];
+			TupleTableSlot *slot = SPI_tuptable->vals[i];
+			HeapTuple	tuple;
 
 			if (tupmap)
-				tuple = do_convert_tuple(tuple, tupmap);
+				tuple = do_convert_tuple(slot->tts_tuple, tupmap);
 			tuplestore_puttuple(estate->tuple_store, tuple);
 			if (tupmap)
 				heap_freetuple(tuple);
@@ -4552,7 +4553,6 @@ exec_assign_value(PLpgSQL_execstate *estate,
 				PLpgSQL_recfield *recfield = (PLpgSQL_recfield *) target;
 				PLpgSQL_rec *rec;
 				int			fno;
-				HeapTuple	newtup;
 				int			colnums[1];
 				Datum		values[1];
 				bool		nulls[1];
@@ -4566,7 +4566,7 @@ exec_assign_value(PLpgSQL_execstate *estate,
 				 * that because records don't have any predefined field
 				 * structure.
 				 */
-				if (!HeapTupleIsValid(rec->tup))
+				if (!HeapTupleIsValid(rec->slot))
 					ereport(ERROR,
 							(errcode(ERRCODE_OBJECT_NOT_IN_PREREQUISITE_STATE),
 							 errmsg("record \"%s\" is not assigned yet",
@@ -4600,15 +4600,9 @@ exec_assign_value(PLpgSQL_execstate *estate,
 											atttypmod);
 				nulls[0] = isNull;
 
-				newtup = heap_modify_tuple_by_cols(rec->tup, rec->tupdesc,
+				rec->slot = heap_modify_slot_by_cols(rec->slot,
 												   1, colnums, values, nulls);
-
-				if (rec->freetup)
-					heap_freetuple(rec->tup);
-
-				rec->tup = newtup;
-				rec->freetup = true;
-
+				rec->freetup = false;
 				break;
 			}
 
@@ -4874,7 +4868,7 @@ exec_eval_datum(PLpgSQL_execstate *estate,
 			{
 				PLpgSQL_rec *rec = (PLpgSQL_rec *) datum;
 
-				if (!HeapTupleIsValid(rec->tup))
+				if (!HeapTupleIsValid(rec->slot))
 					ereport(ERROR,
 							(errcode(ERRCODE_OBJECT_NOT_IN_PREREQUISITE_STATE),
 							 errmsg("record \"%s\" is not assigned yet",
@@ -4887,7 +4881,7 @@ exec_eval_datum(PLpgSQL_execstate *estate,
 				oldcontext = MemoryContextSwitchTo(get_eval_mcontext(estate));
 				*typeid = rec->tupdesc->tdtypeid;
 				*typetypmod = rec->tupdesc->tdtypmod;
-				*value = heap_copy_tuple_as_datum(rec->tup, rec->tupdesc);
+				*value = heap_copy_tuple_as_datum(rec->slot->tts_tuple, rec->tupdesc);
 				*isnull = false;
 				MemoryContextSwitchTo(oldcontext);
 				break;
@@ -4900,7 +4894,7 @@ exec_eval_datum(PLpgSQL_execstate *estate,
 				int			fno;
 
 				rec = (PLpgSQL_rec *) (estate->datums[recfield->recparentno]);
-				if (!HeapTupleIsValid(rec->tup))
+				if (!HeapTupleIsValid(rec->slot))
 					ereport(ERROR,
 							(errcode(ERRCODE_OBJECT_NOT_IN_PREREQUISITE_STATE),
 							 errmsg("record \"%s\" is not assigned yet",
@@ -4917,7 +4911,7 @@ exec_eval_datum(PLpgSQL_execstate *estate,
 					*typetypmod = rec->tupdesc->attrs[fno - 1]->atttypmod;
 				else
 					*typetypmod = -1;
-				*value = SPI_getbinval(rec->tup, rec->tupdesc, fno, isnull);
+				*value = SPI_getbinval(rec->slot, fno, isnull);
 				break;
 			}
 
@@ -5236,8 +5230,7 @@ exec_eval_expr(PLpgSQL_execstate *estate,
 	/*
 	 * Return the single result Datum.
 	 */
-	return SPI_getbinval(estate->eval_tuptable->vals[0],
-						 estate->eval_tuptable->tupdesc, 1, isNull);
+	return SPI_getbinval(estate->eval_tuptable->vals[0], 1, isNull);
 }
 
 
@@ -5936,7 +5929,7 @@ static void
 exec_move_row(PLpgSQL_execstate *estate,
 			  PLpgSQL_rec *rec,
 			  PLpgSQL_row *row,
-			  HeapTuple tup, TupleDesc tupdesc)
+			  TupleTableSlot *slot, TupleDesc tupdesc)
 {
 	/*
 	 * Record is simple - just copy the tuple and its descriptor into the
@@ -5944,30 +5937,13 @@ exec_move_row(PLpgSQL_execstate *estate,
 	 */
 	if (rec != NULL)
 	{
-		/*
-		 * Copy input first, just in case it is pointing at variable's value
-		 */
-		if (HeapTupleIsValid(tup))
-			tup = heap_copytuple(tup);
-		else if (tupdesc)
-		{
-			/* If we have a tupdesc but no data, form an all-nulls tuple */
-			bool	   *nulls;
-
-			nulls = (bool *)
-				eval_mcontext_alloc(estate, tupdesc->natts * sizeof(bool));
-			memset(nulls, true, tupdesc->natts * sizeof(bool));
-
-			tup = heap_form_tuple(tupdesc, NULL, nulls);
-		}
-
 		if (tupdesc)
 			tupdesc = CreateTupleDescCopy(tupdesc);
 
 		/* Free the old value ... */
 		if (rec->freetup)
 		{
-			heap_freetuple(rec->tup);
+			ExecDropSingleTupleTableSlot(rec->slot);
 			rec->freetup = false;
 		}
 		if (rec->freetupdesc)
@@ -5977,13 +5953,13 @@ exec_move_row(PLpgSQL_execstate *estate,
 		}
 
 		/* ... and install the new */
-		if (HeapTupleIsValid(tup))
+		if (HeapTupleIsValid(slot))
 		{
-			rec->tup = tup;
+			ExecCopySlot(rec->slot, slot);
 			rec->freetup = true;
 		}
 		else
-			rec->tup = NULL;
+			rec->slot = NULL;
 
 		if (tupdesc)
 		{
@@ -6019,8 +5995,8 @@ exec_move_row(PLpgSQL_execstate *estate,
 		int			fnum;
 		int			anum;
 
-		if (HeapTupleIsValid(tup))
-			t_natts = HeapTupleHeaderGetNatts(tup->t_data);
+		if (HeapTupleIsValid(slot))
+			t_natts = HeapTupleHeaderGetNatts(slot->tts_tuple->t_data);
 		else
 			t_natts = 0;
 
@@ -6044,7 +6020,7 @@ exec_move_row(PLpgSQL_execstate *estate,
 			if (anum < td_natts)
 			{
 				if (anum < t_natts)
-					value = SPI_getbinval(tup, tupdesc, anum + 1, &isnull);
+					value = SPI_getbinval(slot, anum + 1, &isnull);
 				else
 				{
 					value = (Datum) 0;
@@ -6188,6 +6164,7 @@ exec_move_row_from_datum(PLpgSQL_execstate *estate,
 	int32		tupTypmod;
 	TupleDesc	tupdesc;
 	HeapTupleData tmptup;
+	TupleTableSlot *slot;
 
 	/* Extract rowtype info and find a tupdesc */
 	tupType = HeapTupleHeaderGetTypeId(td);
@@ -6200,8 +6177,11 @@ exec_move_row_from_datum(PLpgSQL_execstate *estate,
 	tmptup.t_tableOid = InvalidOid;
 	tmptup.t_data = td;
 
+	slot = MakeSingleTupleTableSlot(tupdesc);
+	slot->tts_tuple = &tmptup;
+
 	/* Do the move */
-	exec_move_row(estate, rec, row, &tmptup, tupdesc);
+	exec_move_row(estate, rec, row, slot, tupdesc);
 
 	/* Release tupdesc usage count */
 	ReleaseTupleDesc(tupdesc);
diff --git a/src/pl/plpgsql/src/plpgsql.h b/src/pl/plpgsql/src/plpgsql.h
index 2b19948..fc46206 100644
--- a/src/pl/plpgsql/src/plpgsql.h
+++ b/src/pl/plpgsql/src/plpgsql.h
@@ -304,7 +304,7 @@ typedef struct PLpgSQL_rec
 	char	   *refname;
 	int			lineno;
 
-	HeapTuple	tup;
+	TupleTableSlot *slot;
 	TupleDesc	tupdesc;
 	bool		freetup;
 	bool		freetupdesc;
diff --git a/src/pl/plpython/plpy_exec.c b/src/pl/plpython/plpy_exec.c
index c6938d0..63cdc31 100644
--- a/src/pl/plpython/plpy_exec.c
+++ b/src/pl/plpython/plpy_exec.c
@@ -790,36 +790,36 @@ PLy_trigger_build_args(FunctionCallInfo fcinfo, PLyProcedure *proc, HeapTuple *r
 				pltevent = PyString_FromString("INSERT");
 
 				PyDict_SetItemString(pltdata, "old", Py_None);
-				pytnew = PLyDict_FromTuple(&(proc->result), tdata->tg_trigtuple,
+				pytnew = PLyDict_FromTuple(&(proc->result), tdata->tg_trigslot,
 										   tdata->tg_relation->rd_att);
 				PyDict_SetItemString(pltdata, "new", pytnew);
 				Py_DECREF(pytnew);
-				*rv = tdata->tg_trigtuple;
+				*rv = tdata->tg_trigslot;
 			}
 			else if (TRIGGER_FIRED_BY_DELETE(tdata->tg_event))
 			{
 				pltevent = PyString_FromString("DELETE");
 
 				PyDict_SetItemString(pltdata, "new", Py_None);
-				pytold = PLyDict_FromTuple(&(proc->result), tdata->tg_trigtuple,
+				pytold = PLyDict_FromTuple(&(proc->result), tdata->tg_trigslot,
 										   tdata->tg_relation->rd_att);
 				PyDict_SetItemString(pltdata, "old", pytold);
 				Py_DECREF(pytold);
-				*rv = tdata->tg_trigtuple;
+				*rv = tdata->tg_trigslot;
 			}
 			else if (TRIGGER_FIRED_BY_UPDATE(tdata->tg_event))
 			{
 				pltevent = PyString_FromString("UPDATE");
 
-				pytnew = PLyDict_FromTuple(&(proc->result), tdata->tg_newtuple,
+				pytnew = PLyDict_FromTuple(&(proc->result), tdata->tg_newslot,
 										   tdata->tg_relation->rd_att);
 				PyDict_SetItemString(pltdata, "new", pytnew);
 				Py_DECREF(pytnew);
-				pytold = PLyDict_FromTuple(&(proc->result), tdata->tg_trigtuple,
+				pytold = PLyDict_FromTuple(&(proc->result), tdata->tg_trigslot,
 										   tdata->tg_relation->rd_att);
 				PyDict_SetItemString(pltdata, "old", pytold);
 				Py_DECREF(pytold);
-				*rv = tdata->tg_newtuple;
+				*rv = tdata->tg_newslot;
 			}
 			else
 			{
diff --git a/src/pl/tcl/pltcl.c b/src/pl/tcl/pltcl.c
index ed494e1..c335eef 100644
--- a/src/pl/tcl/pltcl.c
+++ b/src/pl/tcl/pltcl.c
@@ -1134,7 +1134,7 @@ pltcl_trigger_handler(PG_FUNCTION_ARGS, pltcl_call_state *call_state,
 									 Tcl_NewStringObj("ROW", -1));
 
 			/* Build the data list for the trigtuple */
-			tcl_trigtup = pltcl_build_tuple_argument(trigdata->tg_trigtuple,
+			tcl_trigtup = pltcl_build_tuple_argument(trigdata->tg_trigslot,
 													 tupdesc);
 
 			/*
@@ -1149,7 +1149,7 @@ pltcl_trigger_handler(PG_FUNCTION_ARGS, pltcl_call_state *call_state,
 				Tcl_ListObjAppendElement(NULL, tcl_cmd, tcl_trigtup);
 				Tcl_ListObjAppendElement(NULL, tcl_cmd, Tcl_NewObj());
 
-				rettup = trigdata->tg_trigtuple;
+				rettup = trigdata->tg_trigslot;
 			}
 			else if (TRIGGER_FIRED_BY_DELETE(trigdata->tg_event))
 			{
@@ -1159,20 +1159,20 @@ pltcl_trigger_handler(PG_FUNCTION_ARGS, pltcl_call_state *call_state,
 				Tcl_ListObjAppendElement(NULL, tcl_cmd, Tcl_NewObj());
 				Tcl_ListObjAppendElement(NULL, tcl_cmd, tcl_trigtup);
 
-				rettup = trigdata->tg_trigtuple;
+				rettup = trigdata->tg_trigslot;
 			}
 			else if (TRIGGER_FIRED_BY_UPDATE(trigdata->tg_event))
 			{
 				Tcl_ListObjAppendElement(NULL, tcl_cmd,
 										 Tcl_NewStringObj("UPDATE", -1));
 
-				tcl_newtup = pltcl_build_tuple_argument(trigdata->tg_newtuple,
+				tcl_newtup = pltcl_build_tuple_argument(trigdata->tg_newslot,
 														tupdesc);
 
 				Tcl_ListObjAppendElement(NULL, tcl_cmd, tcl_newtup);
 				Tcl_ListObjAppendElement(NULL, tcl_cmd, tcl_trigtup);
 
-				rettup = trigdata->tg_newtuple;
+				rettup = trigdata->tg_newslot;
 			}
 			else
 				elog(ERROR, "unrecognized OP tg_event: %u", trigdata->tg_event);
diff --git a/src/test/modules/worker_spi/worker_spi.c b/src/test/modules/worker_spi/worker_spi.c
index 12c8cd5..cb61dcf 100644
--- a/src/test/modules/worker_spi/worker_spi.c
+++ b/src/test/modules/worker_spi/worker_spi.c
@@ -126,7 +126,6 @@ initialize_worker_spi(worktable *table)
 		elog(FATAL, "not a singleton result");
 
 	ntup = DatumGetInt64(SPI_getbinval(SPI_tuptable->vals[0],
-									   SPI_tuptable->tupdesc,
 									   1, &isnull));
 	if (isnull)
 		elog(FATAL, "null result");
@@ -281,7 +280,6 @@ worker_spi_main(Datum main_arg)
 			int32		val;
 
 			val = DatumGetInt32(SPI_getbinval(SPI_tuptable->vals[0],
-											  SPI_tuptable->tupdesc,
 											  1, &isnull));
 			if (!isnull)
 				elog(LOG, "%s: count in %s.%s is now %d",
